unit rDBGridSorter_ElevateDB;

{<
  rDBGridSorter_ElevateDB unit contains TrDBGridSorter_ElevateDB - sorter for TEDBTable
  used by rDBGrid to sort Elevate datasets.

  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(Apr 2020)
  @lastmod(Apr 2020)
}

interface

uses
  Windows, Messages, SysUtils, Graphics, Classes, Controls, Menus, Dialogs,
  StdCtrls, Forms, DB, Variants, rDBGrid,
  EDBComps;

type
  { sorter for TEDBTable used by rDBGrid to sort Elevate datasets }
  TrDBGridSorter_ElevateDB = class(TrDBGridCustomSorter)
  public
    function SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string): boolean; override;
  end;

procedure Register;

implementation

{$R *.res}
uses RosiCompGlobalCfg;

procedure Register;
begin
  RegisterComponents('Rosi DB', [TrDBGridSorter_ElevateDB]);
end;

function TrDBGridSorter_ElevateDB.SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string)
  : boolean;
var
  DS: TEDBTable;
  idxName: string;
begin
  if (DataSet is TEDBTable) then
  begin
    DS:=DataSet as TEDBTable;
    if Trim(SortFields)='' then
      DS.IndexName:=''
    else
    begin
      idxName:=SortFields; // + '_' + DescendingFields;
      if DS.IndexDefs.IndexOf(idxName) < 0 then
      begin
        //  add index is not supported DS.AddIndex(idxName, SortFields, [], DescendingFields);
        // index not found, cannot be sorted
        Result:=false;
        Exit;
      end;
      //DS.IndexDefs.Update;
      DS.IndexName:=idxName;
    end;
    Result:=true;
  end
  else
    Result:= inherited;
end;

end.
